diff -ur sourceold/scripts/jmgUtility.cpp source/scripts/jmgUtility.cpp
--- sourceold/scripts/jmgUtility.cpp	2019-02-15 09:37:36.768000000 +1000
+++ source/scripts/jmgUtility.cpp	2019-06-22 07:43:44.244400000 +1000
@@ -9512,10 +9662,10 @@
 			Commands->Set_Position(spawned,bottomRay);
 		}
 		spawnCount++;
-		char params[32];
+		char params[512];
 		sprintf(params,"%d,%d,%d",Commands->Get_ID(obj),scriptId,spawnGroupId);
 		Commands->Attach_Script(spawned,"JMG_Utility_Basic_Spawner_In_Radius_Attached",params);
-		Commands->Send_Custom_Event(spawned,obj,6873522,6873522,0.0f);
+		Commands->Send_Custom_Event(spawned,obj,6873522,attachScriptsGroupId,0.0f);
 		return SpawnFailureTypes::SUCCESS;
 	}
 	if (!ignoreRayCastFailure)
@@ -9527,15 +9677,26 @@
 }
 void JMG_Utility_Basic_Spawner_In_Radius::Initial_Spawn(GameObject *obj)
 {
-	for (int x = 0;x < initialSpawn;x++)
+	int addSpawn = GetPlayerLimitModifier();
+	for (int x = spawnedObjects;x < initialSpawn+addSpawn;x++)
+	{
+		JMG_Utility_Basic_Spawner_In_Radius::SpawnFailureTypes spawnResult;
 		for (int y = 0;y < 5;y++)
 		{
-			JMG_Utility_Basic_Spawner_In_Radius::SpawnFailureTypes spawnResult = AttemptSpawn(obj);
+			 spawnResult = AttemptSpawn(obj);
 			if (spawnResult == SpawnFailureTypes::SUCCESS)
 				break;
 			if (spawnResult == SpawnFailureTypes::LIMIT_REACHED)
-				x = initialSpawn+1;
+				x = initialSpawn+1+addSpawn;
 		}
+		if (spawnResult == SpawnFailureTypes::SPAWN_BLOCKED)
+			Commands->Send_Custom_Event(obj,obj,6873525,scriptId,0.1f);
+		if (initialSpawn < spawnAtATime)
+		{
+			Stop_Timer(obj,1);
+			Commands->Start_Timer(obj,this,0.1f,1);
+		}
+	}
 }
 bool JMG_Utility_Basic_Spawner_In_Radius::CheckIfObjectIsNearAnotherObject(Vector3 pos)
 {
@@ -9557,13 +9718,17 @@
 {
 	if (obj->As_SoldierGameObj())
 	{
-		char params[220];
+		char params[512];
 		sprintf(params,"0.1,%.2f",facing);
 		Commands->Attach_Script(obj,"JMG_Utility_Delay_Then_Rotate_Camera",params);
 	}
 	else
 		Commands->Set_Facing(obj,facing);
 }
+int JMG_Utility_Basic_Spawner_In_Radius::GetPlayerLimitModifier()
+{
+	return (int)playersAddToSpawnAtATime*Get_Player_Count();
+}
 void JMG_Utility_Basic_Spawner_In_Radius_Attached::Created(GameObject *obj)
 {
 	GameObject *controller = Commands->Find_Object(Get_Int_Parameter("Controller_ID"));
@@ -9658,24 +9823,45 @@
 	visibleParam = Get_Int_Parameter("Visible_Param");
 	notVisibleParam = Get_Int_Parameter("Not_Visible_Param");
 	maxNotSeenTime = (int)(Get_Float_Parameter("Max_Lost_Sight_Time")*10);
+	repeatSendSeenCustom = Get_Int_Parameter("RepeatSendSeenCustom") != 0;
+	carTankBike = Get_Vector3_Parameter("AttackPriority[Car|Tank|Bike]");
+	flyingTurretBoat = Get_Vector3_Parameter("AttackPriority[Flying|Turret|Boat]");
+	submarineInfantryUnused = Get_Vector3_Parameter("AttackPriority[Submarine|Infantry|Unused]");
 	Commands->Enable_Enemy_Seen(obj,true);
 	Commands->Start_Timer(obj,this,0.1f,1);
 }
 void JMG_Utility_Enemy_Seen_Send_Custom::Enemy_Seen(GameObject *obj,GameObject *seen)
 {
+	GameObject *vehicle = Get_Vehicle(seen);
+	if (vehicle)
+		seen = vehicle;
 	if (!JmgUtility::CanSeeStealth(0,obj,seen))
 		return;
+	float seenPriority = GetPriority(seen);
+	if (!seenPriority)
+		return;
 	if (enemyPresetId && enemyPresetId != Commands->Get_Preset_ID(seen))
 		return;
 	if (Is_Script_Attached(seen,"JMG_Utility_Enemy_Seen_Send_Custom_Ignore"))
 		return;
+	if (!Commands->Get_Health(seen))
+		return;
 	int seenId = Commands->Get_ID(seen);
-	if (!seenTime)
+	if (!seenTime || !lastEnemyId)
 	{
-		GameObject *object = !id ? obj : (id == -1 ? seen : Commands->Find_Object(id));
-		if (object)
-			Commands->Send_Custom_Event(obj,object,visibleMessage,visibleParam,0);
 		lastEnemyId = seenId;
+		SendCustom(obj,visibleMessage,visibleParam);
+	}
+	else if (lastEnemyId != seenId)
+	{
+		GameObject *enemy = Commands->Find_Object(seenId);
+		if (!enemy || seenPriority > GetPriority(enemy))
+		{
+			if (lastEnemyId)
+				SendCustom(obj,notVisibleMessage,notVisibleParam);
+			lastEnemyId = seenId;
+			SendCustom(obj,visibleMessage,visibleParam);
+		}
 	}
 	if (lastEnemyId == seenId)
 		seenTime = maxNotSeenTime;
@@ -9685,19 +9871,53 @@
 {
 	if (number == 1)
 	{
+		GameObject *target = Commands->Find_Object(lastEnemyId);
+		if (!target || !Commands->Get_Health(target))
+		{
+			SendCustom(obj,notVisibleMessage,notVisibleParam);
+			lastEnemyId = 0;
+			seenTime = 0;
+		}
 		if (seenTime)
 		{
 			seenTime--;
 			if (!seenTime)
 			{
-				GameObject *object = !id ? obj : (id == -1 ? Commands->Find_Object(lastEnemyId) : Commands->Find_Object(id));
-				if (object)
-					Commands->Send_Custom_Event(obj,object,notVisibleMessage,notVisibleParam,0);
+				SendCustom(obj,notVisibleMessage,notVisibleParam);
+				lastEnemyId = 0;
 			}
 		}
+		if (repeatSendSeenCustom && target && seenTime)
+			SendCustom(obj,visibleMessage,visibleParam);
 		Commands->Start_Timer(obj,this,0.1f,1);
 	}
 }
+float JMG_Utility_Enemy_Seen_Send_Custom::GetPriority(GameObject *seen)
+{
+	if (seen->As_VehicleGameObj())
+		switch (Get_Vehicle_Mode(seen))
+		{
+			case VEHICLE_TYPE_CAR: return carTankBike.X;
+			case VEHICLE_TYPE_TANK: return carTankBike.Y;
+			case VEHICLE_TYPE_BIKE: return carTankBike.Z;
+			case VEHICLE_TYPE_FLYING: return flyingTurretBoat.X;
+			case VEHICLE_TYPE_TURRET: return flyingTurretBoat.Y;
+			case VEHICLE_TYPE_BOAT: return flyingTurretBoat.Z;
+			case VEHICLE_TYPE_SUB: return submarineInfantryUnused.X;
+		}
+	else if (seen->As_SoldierGameObj())
+		return submarineInfantryUnused.Y;
+	Console_Input("msg JMG_Utility_Enemy_Seen_Send_Custom ERROR: Undefined vehicle type!");
+	return 0;
+}
+void JMG_Utility_Enemy_Seen_Send_Custom::SendCustom(GameObject *obj,int custom,int param)
+{
+	if (!custom)
+		return;
+	GameObject *object = !id ? obj : (id == -1 ? Commands->Find_Object(lastEnemyId) : Commands->Find_Object(id));
+	if (object)
+		Commands->Send_Custom_Event(obj,object,custom,param == -1 ? lastEnemyId : param,0);
+}
 void JMG_Utility_Custom_Send_Custom_If_Script_Attached::Created(GameObject *obj)
 {
 	recieveMessage = Get_Int_Parameter("Custom");
@@ -9736,6 +9956,10 @@
 {
 	JMG_Utility_Basic_Spawner_In_Radius::spawnObjectNodeList.Remove_All();
 }
+void JMG_Utility_Basic_Spawner_In_Radius_Controller::Detach(GameObject *obj)
+{
+	Destroyed(obj);
+}
 void JMG_Utility_Custom_Set_Engine::Created(GameObject *obj)
 {
 	custom = Get_Int_Parameter("Custom");
@@ -10140,6 +10364,8 @@
 }
 void JMG_Utility_AI_Skittish_Herd_Animal::Enemy_Seen(GameObject *obj,GameObject *seen)	
 {
+	if (!Commands->Get_Health(seen))
+		return;
 	if (((HerdAnimalPositionControl[herdId].checkRetreatCloseEnough() || difftime(clock(),HerdAnimalPositionControl[herdId].herdRetreatStart) > HerdAnimalPositionControl[herdId].herdRetreatTime)))
 		setRetreatLocation(obj,seen);
 }
@@ -10280,6 +10506,10 @@
 	for (int x = 0;x < 128;x++)
 		JMG_Utility_AI_Skittish_Herd_Animal::HerdAnimalPositionControl[x].Empty_List();
 }
+void JMG_Utility_AI_Skittish_Herd_Animal_Controller::Detach(GameObject *obj)
+{
+	Destroyed(obj);
+}
 void JMG_Utility_Custom_Display_Dialog_Box::Created(GameObject *obj)
 {
 	custom = Get_Int_Parameter("Custom");
@@ -10803,6 +11033,10 @@
 	exists = false;
 	Empty_List();
 }
+void JMG_Utility_Swimming_Infantry_Advanced_Controller::Detach(GameObject *obj)
+{
+	Destroyed(obj);
+}
 void JMG_Utility_Swimming_Infantry_Advanced_Add_All_Of_Style::Created(GameObject *obj)
 {
 	if (!JMG_Utility_Swimming_Infantry_Advanced_Controller::exists)
